Telerik.Web.UI.RadComboBoxEventArgs=function(){
Telerik.Web.UI.RadComboBoxEventArgs.initializeBase(this);
};
Telerik.Web.UI.RadComboBoxEventArgs.prototype={};
Telerik.Web.UI.RadComboBoxEventArgs.registerClass("Telerik.Web.UI.RadComboBoxEventArgs",Sys.EventArgs);
Telerik.Web.UI.RadComboBoxCancelEventArgs=function(){
Telerik.Web.UI.RadComboBoxCancelEventArgs.initializeBase(this);
};
Telerik.Web.UI.RadComboBoxCancelEventArgs.prototype={};
Telerik.Web.UI.RadComboBoxCancelEventArgs.registerClass("Telerik.Web.UI.RadComboBoxCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.RadComboBoxItemEventArgs=function(_1){
Telerik.Web.UI.RadComboBoxItemEventArgs.initializeBase(this);
this._item=_1;
};
Telerik.Web.UI.RadComboBoxItemEventArgs.prototype={get_item:function(){
return this._item;
}};
Telerik.Web.UI.RadComboBoxItemEventArgs.registerClass("Telerik.Web.UI.RadComboBoxItemEventArgs",Sys.EventArgs);
Telerik.Web.UI.RadComboBoxItemCancelEventArgs=function(_2){
Telerik.Web.UI.RadComboBoxItemCancelEventArgs.initializeBase(this);
this._item=_2;
};
Telerik.Web.UI.RadComboBoxItemCancelEventArgs.prototype={get_item:function(){
return this._item;
}};
Telerik.Web.UI.RadComboBoxItemCancelEventArgs.registerClass("Telerik.Web.UI.RadComboBoxItemCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.RadComboBoxRequestEventArgs=function(_3){
Telerik.Web.UI.RadComboBoxRequestEventArgs.initializeBase(this);
this._text=_3;
};
Telerik.Web.UI.RadComboBoxRequestEventArgs.prototype={get_text:function(){
return this._text;
}};
Telerik.Web.UI.RadComboBoxRequestEventArgs.registerClass("Telerik.Web.UI.RadComboBoxRequestEventArgs",Sys.EventArgs);
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs=function(_4,_5){
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs.initializeBase(this);
this._text=_4;
this._context=_5;
};
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs.prototype={get_text:function(){
return this._text;
},get_context:function(){
return this._context;
}};
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs.registerClass("Telerik.Web.UI.RadComboBoxRequestCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs=function(_6,_7){
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs.initializeBase(this);
this._text=_6;
this._errorMessage=_7;
};
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs.prototype={get_text:function(){
return this._text;
},get_errorMessage:function(){
return this._errorMessage;
}};
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs.registerClass("Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs",Telerik.Web.UI.RadComboBoxCancelEventArgs);;Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.Keys=function(){
};
Telerik.Web.UI.Keys.prototype={Shift:16,Escape:27,Up:38,Down:40,Left:37,Right:39,Enter:13,Tab:9,Space:32,PageUp:33,Del:46,F1:112,F12:123};
Telerik.Web.UI.Keys.registerEnum("Telerik.Web.UI.Keys");
Telerik.Web.UI.RadComboBox=function(_1){
Telerik.Web.UI.RadComboBox.initializeBase(this,[_1]);
this._changeText=true;
this._children=null;
this._virtualScroll=true;
this._itemData=null;
this._selectedItem=null;
this._selectedIndex=null;
this._highlightedItem=null;
this._dropDownVisible=false;
this._enableLoadOnDemand=false;
this._openDropDownOnLoad=false;
this._appendItems=false;
this._allowCustomText=false;
this._markFirstMatch=false;
this._originalText=this.get_inputDomElement().value;
this._cachedText=this._originalText;
this._text="";
this._value=null;
this._isCaseSensitive=false;
this._autoCompleteSeparator=null;
this._postBackReference=null;
this._dropDownElement=null;
this._inputDomElement=null;
this._imageDomElement=null;
this._tableElement=null;
this._itemRequestTimeout=300;
this._isTemplated=false;
this._requestTimeoutID=0;
this._highlightTemplatedItems=false;
this._clientState={value:"",text:"",enabled:true,logEntries:[]};
this._uniqueId=null;
this._rightToLeft=false;
this._isDetached=false;
this._offsetX=0;
this._offsetY=0;
this._overlay=null;
this._enableScreenBoundaryDetection=true;
this._suppressChange=false;
this._lastKeyCode=null;
this._loadingDiv=null;
this._loadingMessage="Loading...";
this._showMoreResultsBox=false;
this._closeDropDownOnBlur=true;
this._focused=false;
this._causesValidation=true;
this.get_inputDomElement().setAttribute("autocomplete","off");
this._errorMessage="CallBack Error!";
this._showMoreMessage="";
this._webServiceSettings=new Telerik.Web.UI.WebServiceSettings({});
this._webServiceLoader=null;
this._clientDataString=null;
this._scrollbarWidth=16;
this._enabled=true;
this._fireEvents=this._enabled;
this._slide=null;
this._expandAnimation=new Telerik.Web.UI.AnimationSettings({});
this._expandDelay=100;
this._collapseAnimation=new Telerik.Web.UI.AnimationSettings({});
this._collapseDelay=500;
this._slideDirection=Telerik.Web.UI.SlideDirection.Down;
this._expandAnimationEndedDelegate=null;
this._expandAnimationStartedDelegate=null;
this._showDropDownOnTextboxClick=true;
this._dropDownWidth="";
this._height="";
this._childListElementWrapper=null;
this._skin="";
this._skipLoadingItems=false;
this._ajaxRequest=false;
this._endOfItems=false;
this._isInPostBack=false;
this._emptyMessage=null;
};
Telerik.Web.UI.RadComboBox.ComboBoxes=[];
Telerik.Web.UI.RadComboBox._createChildControls=function(_2,_3){
var _4=_2.get_itemData();
if(!_4){
return;
}
var _5=_2.get_childListElement();
if(!_5){
return;
}
var _6=$telerik.getChildrenByTagName(_2.get_childListElement(),"li");
var _7=_6.length;
var _8=0;
if(_6.length>0&&_6[0].className=="rcbLoading"){
_7=_7-1;
_8=1;
}
Sys.Debug.assert(_4.length==_7,"Length of elements and json must be the same!");
for(var i=_8;i<_6.length;i++){
var _a=new Telerik.Web.UI.RadComboBoxItem();
_3.add(_a);
_a._initialize(_4[i-_8],_6[i]);
}
};
Telerik.Web.UI.RadComboBox.prototype={initialize:function(){
Telerik.Web.UI.RadComboBox.callBaseMethod(this,"initialize");
if(this._requiresRightToLeft()){
this._initRightToLeft();
}
if(this.get_childListElement()){
this._onDropDownClickDelegate=Function.createDelegate(this,this._onDropDownClick);
$addHandler(this.get_childListElement(),"click",this._onDropDownClickDelegate);
this._onDropDownHoverDelegate=Function.createDelegate(this,this._onDropDownHover);
$addHandler(this.get_childListElement(),"mouseover",this._onDropDownHoverDelegate);
$addHandler(this.get_childListElement(),"selectstart",this._cancelEvent);
$addHandler(this.get_childListElement(),"dragstart",this._cancelEvent);
this._onDropDownOutDelegate=Function.createDelegate(this,this._onDropDownOut);
$addHandler(this.get_childListElement(),"mouseout",this._onDropDownOutDelegate);
}
this._onTableHoverDelegate=Function.createDelegate(this,this._onTableHover);
$addHandler(this.get_tableElement(),"mouseover",this._onTableHoverDelegate);
this._onTableOutDelegate=Function.createDelegate(this,this._onTableOut);
$addHandler(this.get_tableElement(),"mouseout",this._onTableOutDelegate);
this._onPropertyChangeDelegate=Function.createDelegate(this,this._onInputPropertyChange);
$addHandler(this.get_inputDomElement(),"propertychange",this._onPropertyChangeDelegate);
this._onFocusDelegate=Function.createDelegate(this,this._onFocus);
$addHandler(this.get_inputDomElement(),"focus",this._onFocusDelegate);
this._onDocumentClickDelegate=Function.createDelegate(this,this._onDocumentClick);
$addHandler(document,"mousedown",this._onDocumentClickDelegate);
$addHandler(document,"contextmenu",this._onDocumentClickDelegate);
this._onDropDownScrollDelegate=Function.createDelegate(this,this._onDropDownScroll);
$addHandler(this.get_childListElementWrapper(),"scroll",this._onDropDownScrollDelegate);
this._eventMap.addHandlerForClassName("click","rcbInput",this._onInputClick);
this._eventMap.addHandlerForClassName("keydown","rcbInput",this._onKeyDown);
this._eventMap.addHandlerForClassName("focus","rcbInput",this._onFocus);
if(!$telerik.isIE){
this._eventMap.addHandlerForClassName("input","rcbInput",this._onInputChange);
}
if(this.get_imageDomElement()){
this._onImageClickDelegate=Function.createDelegate(this,this._onImageClick);
$addHandler(this.get_imageDomElement(),"click",this._onImageClickDelegate);
}
this._onWindowResizeDelegate=Function.createDelegate(this,this._onWindowResize);
$addHandler(window,"resize",this._onWindowResizeDelegate);
if(this._openDropDownOnLoad){
this._onOpenOnLoad=Function.createDelegate(this,this.showDropDown);
$addHandler(window,"load",this._onOpenOnLoad);
}
if(this.get_moreResultsBoxElement()){
this._onMoreResultsBoxClickDelegate=Function.createDelegate(this,this._onMoreResultsBoxClick);
$addHandler(this.get_moreResultsBoxElement(),"click",this._onMoreResultsBoxClickDelegate);
this._onMoreResultsBoxOverDelegate=Function.createDelegate(this,this._onMoreResultsBoxOver);
$addHandler(this.get_moreResultsBoxElement(),"mouseover",this._onMoreResultsBoxOverDelegate);
this._onMoreResultsBoxOutDelegate=Function.createDelegate(this,this._onMoreResultsBoxOut);
$addHandler(this.get_moreResultsBoxElement(),"mouseout",this._onMoreResultsBoxOutDelegate);
}
var _b=this.findItemByText(this._text);
if(_b){
this.set_selectedItem(_b);
}
this._initializeAnimation();
if(this._openDropDownOnLoad&&!this.get_dropDownVisible()){
this.showDropDown();
}
var me=this;
this.updateClientState();
this._beforePostbackHandler=Function.createDelegate(this,this._backUpDropDown);
Telerik.Web.UI.PostbackWrapper.add_beforePostback(this._beforePostbackHandler);
Array.add(Telerik.Web.UI.RadComboBox.ComboBoxes,this);
if(this._fireEvents){
this.raiseEvent("load",null);
}
if(Sys.WebForms&&Sys.WebForms.PageRequestManager){
this._endRequestHandler=Function.createDelegate(this,this._onEndRequest);
Sys.WebForms.PageRequestManager.getInstance().add_endRequest(this._endRequestHandler);
}
this.get_element().value=this._text;
var _d=this.get_element().style.zIndex;
var _e=this.get_dropDownElement().parentNode.style.zIndex;
if(_d==0){
_d=_e;
}
this.get_dropDownElement().parentNode.style.zIndex=_d;
},_initializeAnimation:function(){
var _f=this._getAnimatedElement();
if(_f){
this._slide=new Telerik.Web.UI.Slide(_f,this.get_expandAnimation(),this.get_collapseAnimation());
this._slide.initialize();
this._slide.set_direction(this.get_slideDirection());
}
this._expandAnimationEndedDelegate=Function.createDelegate(this,this._onExpandAnimationEnded);
this._slide.add_expandAnimationEnded(this._expandAnimationEndedDelegate);
this._expandAnimationStartedDelegate=Function.createDelegate(this,this._onExpandAnimationStarted);
this._slide.add_expandAnimationStarted(this._expandAnimationStartedDelegate);
},_onExpandAnimationEnded:function(_10,e){
if(window.netscape&&!window.opera){
this.get_childListElementWrapper().style.overflow="auto";
if(this.get_selectedItem()){
this.get_selectedItem().scrollOnTop();
}
}
},_onExpandAnimationStarted:function(_12,e){
if(window.netscape&&!window.opera){
this.get_childListElementWrapper().style.overflow="hidden";
}
},_requiresRightToLeft:function(){
var _14=this.get_element();
while(_14.nodeType!==9){
if(_14.dir=="rtl"){
return true;
}
_14=_14.parentNode;
}
return false;
},_initRightToLeft:function(){
this._rightToLeft=true;
if(this._skin){
this.get_element().className=String.format("{0} RadComboBox_{1}_rtl",this.get_element().className,this._skin);
this.get_dropDownElement().className=String.format("{0} RadComboBoxDropDown_{1}_rtl",this.get_dropDownElement().className,this._skin);
}
if(this.get_imageDomElement()){
if(Sys.UI.DomElement.containsCssClass(this.get_imageDomElement().parentNode,"rcbArrowCellRight")){
this._replaceCssClass(this.get_imageDomElement().parentNode,"rcbArrowCellRight","rcbArrowCellLeft");
this.get_inputDomElement().parentNode.className="rcbInputCell rcbInputCellRight";
}else{
this._replaceCssClaBss(this.get_imageDomElement().parentNode,"rcbArrowCellLeft","rcbArrowCellRight");
this.get_inputDomElement().parentNode.className="rcbInputCell rcbInputCellLeft";
}
}
},_replaceCssClass:function(_15,_16,_17){
_15.className=_15.className.replace(_16,_17);
},dispose:function(){
this._originalDomPositionHelper=null;
if(Sys.WebForms&&Sys.WebForms.PageRequestManager){
Sys.WebForms.PageRequestManager.getInstance().remove_endRequest(this._endRequestHandler);
}
Array.remove(Telerik.Web.UI.RadComboBox.ComboBoxes,this);
Telerik.Web.UI.PostbackWrapper.remove_beforePostback(this._beforePostbackHandler);
Telerik.Web.UI.RadComboBox.callBaseMethod(this,"dispose");
if(this._expandAnimationEndedDelegate){
if(this._slide){
this._slide.remove_expandAnimationEnded(this._expandAnimationEndedDelegate);
}
this._expandAnimationEndedDelegate=null;
}
if(this._expandAnimationStartedDelegate){
if(this._slide){
this._slide.remove_expandAnimationStarted(this._expandAnimationStartedDelegate);
}
this._expandAnimationStartedDelegate=null;
}
$removeHandler(window,"resize",this._onWindowResizeDelegate);
$removeHandler(this.get_inputDomElement(),"propertychange",this._onPropertyChangeDelegate);
$removeHandler(this.get_inputDomElement(),"focus",this._onFocusDelegate);
$removeHandler(document,"mousedown",this._onDocumentClickDelegate);
$removeHandler(document,"contextmenu",this._onDocumentClickDelegate);
if(this.get_childListElement()){
$removeHandler(this.get_childListElement(),"click",this._onDropDownClickDelegate);
$removeHandler(this.get_childListElement(),"mouseover",this._onDropDownHoverDelegate);
$removeHandler(this.get_childListElement(),"mouseout",this._onDropDownOutDelegate);
$removeHandler(this.get_childListElement(),"selectstart",this._cancelEvent);
$removeHandler(this.get_childListElement(),"dragstart",this._cancelEvent);
}
if(this.get_tableElement()){
$removeHandler(this.get_tableElement(),"mouseover",this._onTableHoverDelegate);
$removeHandler(this.get_tableElement(),"mouseout",this._onTableOutDelegate);
}
if(this.get_imageDomElement()){
$removeHandler(this.get_imageDomElement(),"click",this._onImageClickDelegate);
}
if(this._openDropDownOnLoad){
$removeHandler(window,"load",this._onOpenOnLoad);
}
if(this.get_moreResultsBoxElement()){
$removeHandler(this.get_moreResultsBoxElement(),"click",this._onMoreResultsBoxClickDelegate);
$removeHandler(this.get_moreResultsBoxElement(),"mouseover",this._onMoreResultsBoxOverDelegate);
$removeHandler(this.get_moreResultsBoxElement(),"mouseout",this._onMoreResultsBoxOutDelegate);
}
$removeHandler(this.get_childListElementWrapper(),"scroll",this._onDropDownScrollDelegate);
if(this._slide){
this._slide.dispose();
this._slide=null;
}
},_cancelEvent:function(e){
e.preventDefault();
return false;
},_onDropDownScroll:function(e){
if(!this._virtualScroll||this._ajaxRequest||this._endOfItems){
return;
}
var _1a=this.get_items().get_count();
var _1b=22;
var _1c=0;
if(_1a>0){
_1b=this.get_items().getItem(0).get_element().offsetHeight;
_1c=this.get_items().getItem(_1a-1).get_element().offsetTop;
}
var _1d=$telerik.getFirstChildByTagName(this.get_childListElement(),"div",0);
if(_1d){
var _1e=_1d.offsetHeight;
if(this.get_childListElementWrapper().scrollTop+_1e>=this.get_childListElement().offsetHeight-_1e){
this.requestItems(this.get_text(),true);
}
}
},_initOriginalDomPositionHelper:function(){
this._originalDomPositionHelper=document.createElement("div");
this._originalDomPositionHelper.style.display="none";
var _1f=this.get_dropDownElement().parentNode;
_1f.parentNode.insertBefore(this._originalDomPositionHelper,_1f);
},_detachDropDown:function(){
if(!this._originalDomPositionHelper){
this._initOriginalDomPositionHelper();
}
if((!document.readyState||document.readyState=="complete")&&(!this._isDetached)){
var _20=this._findParentForm();
var _21=this.get_dropDownElement();
var _22=this.get_dropDownElement().parentNode;
_22.parentNode.removeChild(_22);
_22.style.marginLeft="0";
_20.insertBefore(_22,_20.firstChild);
this._isDetached=true;
}
},_attachDropDown:function(){
if(this._isDetached){
var _23=this.get_dropDownElement();
var _24=this.get_dropDownElement().parentNode;
_24.parentNode.removeChild(_24);
_24.style.marginLeft="0";
this._originalDomPositionHelper.parentNode.insertBefore(_24,this._originalDomPositionHelper);
this._isDetached=false;
_24.style.display="none";
}
},_onEndRequest:function(_25,_26){
this._isInPostBack=false;
},_backUpDropDown:function(){
this._attachDropDown();
this._isInPostBack=true;
},_findParentForm:function(){
var _27=this.get_element();
while(_27.tagName.toLowerCase()!="form"){
_27=_27.parentNode;
}
return _27;
},_findNearestItem:function(_28){
while(_28.nodeType!==9){
if(_28._item&&Telerik.Web.UI.RadComboBoxItem.isInstanceOfType(_28._item)){
return _28._item;
}
_28=_28.parentNode;
}
return null;
},_positionDropDown:function(){
this._detachDropDown();
var _29=this.get_element();
var _2a=this._getAnimationContainer();
_2a.style.position="absolute";
var _2b=$telerik.getLocation(_29);
var _2c=this.get_dropDownElement();
var _2d=this.get_element().offsetWidth;
if(this._dropDownWidth){
_2d=this._dropDownWidth;
}
var _2e=this.get_childListElement();
var _2f=this.get_childListElementWrapper();
var _30=_2b.y+this.get_offsetY()+this.get_element().offsetHeight;
_2a.style.top=_30+"px";
_2a.style.left=_2b.x+this.get_offsetX()+"px";
if(this._rightToLeft&&document.body.dir=="rtl"){
_2a.style.left="";
_2a.style.left=_2b.x+this.get_offsetX()-this._getScrollBarWidth()+"px";
}
_2c.style.display="block";
_2c.style.width=_2d+"px";
var _31=0;
if(!this._dropDownWidth){
_31=_2c.offsetWidth-_2d;
}
if(_31>0&&_31<_2d){
_2c.style.width=_2d-_31+"px";
}
if(this._rightToLeft){
_2c.dir="rtl";
}
this._determineScreenBoundaryDetection();
},_calculateDropDownAutoHeight:function(){
var _32=this.get_dropDownElement();
var _33=this._getAnimationContainer();
var _34=$telerik.getLocation(this.get_element());
var _33=this._getAnimationContainer();
var _35=$telerik.getLocation(_33);
var _36=$telerik.getViewPortSize();
var y=_34.y-_32.offsetHeight;
var _38=_36.height-_35.y;
var _39=_35.y-this.get_element().offsetHeight;
var _3a=_38;
var _3b=false;
var _3c=0;
if(this._getHeaderElement()){
_3c=_3c+this._getHeaderElement().offsetHeight;
_3b=true;
}
if(this.get_moreResultsBoxElement()){
_3c=_3c+this.get_moreResultsBoxElement().offsetHeight;
_3b=true;
}
if(this._enableScreenBoundaryDetection&&_38<_39){
_3a=_39;
}
if(!(_3a>=0&&(this.get_childListElement().offsetHeight+_3c)>=_3a)){
_3a=this.get_childListElement().offsetHeight+_3c;
}
if(_3b&&_3c<_3a){
this.get_childListElementWrapper().style.height=_3a-_3c+"px";
}else{
this.get_childListElementWrapper().style.height=_3a+"px";
}
return _3a;
},_determineScreenBoundaryDetection:function(){
var _3d=this.get_dropDownElement();
var _3e=this._getAnimationContainer();
var _3f=$telerik.getLocation(this.get_element());
var _3e=this._getAnimationContainer();
var _40=$telerik.getLocation(_3e);
var _41=$telerik.getViewPortSize();
var _42=_3d.offsetHeight;
if(this._height==""&&this.get_childListElement()){
_42=this._calculateDropDownAutoHeight();
}
if(this._enableScreenBoundaryDetection){
if(this._elementOverflowsBottom(_41,_3d,this.get_inputDomElement())){
var y=_3f.y-_42;
if(y>=0){
this.set_slideDirection(Telerik.Web.UI.SlideDirection.Up);
this._getAnimationContainer().style.height=this.get_dropDownElement().offsetHeight;
this._getAnimationContainer().style.top=_3f.y-this.get_offsetY()-_3d.offsetHeight+"px";
if(window.netscape&&!window.opera){
this._getAnimationContainer().style.top=_3f.y-this.get_offsetY()-_3d.offsetHeight+2+"px";
}
if(this._height==""&&_42==_40.y-this.get_element().offsetHeight){
this._getAnimationContainer().style.top="0px";
}
}else{
this.set_slideDirection(Telerik.Web.UI.SlideDirection.Down);
}
}else{
this.set_slideDirection(Telerik.Web.UI.SlideDirection.Down);
}
}
this.set_dropDownVisible(true);
},_getScrollBarWidth:function(){
var _44,_45=0;
var _46=document.createElement("div");
_46.style.position="absolute";
_46.style.top="-1000px";
_46.style.left="-1000px";
_46.style.width="100px";
_46.style.height="50px";
_46.style.overflow="hidden";
var _47=document.createElement("div");
_47.style.width="100%";
_47.style.height="200px";
_46.appendChild(_47);
document.body.appendChild(_46);
var _48=_47.offsetWidth;
_46.style.overflow="auto";
var _49=_47.offsetWidth;
this._scrollbarWidth=_48-_49;
if(this._scrollbarWidth<=0){
_47.style.width="300px";
_44=_46.offsetWidth;
_45=_46.clientWidth;
this._scrollbarWidth=_44-_45;
}
if(this._scrollbarWidth<=0){
this._scrollbarWidth=16;
}
document.body.removeChild(document.body.lastChild);
return this._scrollbarWidth;
},_elementOverflowsBottom:function(_4a,_4b,_4c){
var _4d=$telerik.getLocation(_4c).y+_4b.offsetHeight;
return _4d>_4a.height;
},_selectFirstMatch:function(){
var _4e=this._findItemToSelect();
if(_4e&&_4e.get_enabled()){
_4e.highlight();
_4e.scrollOnTop();
this.set_selectedItem(_4e);
}
},_findItemToSelect:function(){
var _4f=this.findItemByValue(this.get_value());
if(!_4f){
_4f=this.findItemByText(this.get_text());
}
return _4f;
},clearItems:function(){
this.set_selectedItem(null);
this.set_highlightedItem(null);
this.get_items().clear();
},clearSelection:function(){
this.set_text("");
this.set_value("");
this.set_selectedItem(null);
this.set_highlightedItem(null);
},_findNextAvailableIndex:function(_50){
var _51=this.get_items();
for(var i=_50;i<_51.get_count();i++){
if(_51.getItem(i).get_enabled()){
return i;
}
}
return _51.get_count();
},_findPrevAvailableIndex:function(_53){
var _54=this.get_items();
if(_54.get_count()<1){
return -1;
}
for(var i=_53;i>=0;i--){
if(_54.getItem(i).get_enabled()){
return i;
}
}
return -1;
},_onDropDownClick:function(e){
if(!this._enabled){
return;
}
var _57=this._findNearestItem(e.target);
if(!_57||!_57.get_enabled()){
return;
}
this.hideDropDown();
this._performSelect(_57);
},_onDropDownHover:function(e){
if(!this._enabled||this._ajaxRequest){
return;
}
var _59=this._findNearestItem(e.target);
if(!_59||!_59.get_enabled()){
return;
}
_59.highlight();
},_onDropDownOut:function(e){
if(!this._enabled){
return;
}
if(!e){
e=event;
}
var _5b;
try{
_5b=e.toElement||e.relatedTarget||e.fromElement;
while(_5b.nodeType!==9){
if(_5b.parentNode==this.get_dropDownElement()){
return;
}
_5b=_5b.parentNode;
}
}
catch(e){
}
var _5c=this.get_highlightedItem();
if(_5c){
_5c.unHighlight();
}
},_onTableHover:function(e){
if(!this._enabled){
return;
}
var _5e=this.get_tableElement();
if(_5e!=null&&_5e.className!="rcbFocused"){
_5e.className="rcbHovered";
}
},_onTableOut:function(e){
if(!this._enabled){
return;
}
if(!e){
e=event;
}
var _60=this.get_tableElement();
var _61=e.target||e.srcElement;
var _62=e.toElement||e.relatedTarget||e.fromElement;
while(_62&&_62.nodeType!==9){
if(_62.parentNode&&_62.parentNode==_60){
return;
}
_62=_62.parentNode;
}
if(_60!=null&&_60.className=="rcbHovered"){
_60.className="";
}
},_onDocumentClick:function(e){
if(!e){
e=event;
}
var _64=e.target||e.srcElement;
while(_64.nodeType!==9){
if(_64.parentNode==null||_64==this.get_element()||_64==this.get_dropDownElement()){
return;
}
_64=_64.parentNode;
}
if(this.get_dropDownVisible()&&this.get_closeDropDownOnBlur()){
this.hideDropDown();
}
if(this._focused){
this._raiseClientBlur();
this._selectItemOnBlur();
this._focused=false;
}
},_selectItemOnBlur:function(){
var _65=this._findItemToSelect();
if(!_65&&!this.get_allowCustomText()&&this.get_items().get_count()>0){
if(this.get_markFirstMatch()){
if(this.get_text()==""){
this.set_text(this._originalText);
}
this.highlightMatches();
this.selectText(0,0);
_65=this.get_highlightedItem();
}
}
this._performSelect(_65);
},_onWindowResize:function(){
if(this.get_dropDownVisible()){
this._positionDropDown();
}
},_onKeyDown:function(e){
if(!this._fireEvents||this._ajaxRequest){
return;
}
if(!e){
e=event;
}
this.raise_onClientKeyPressing(e);
var _67=e.keyCode||e.which;
this._lastKeyCode=_67;
if(_67==Telerik.Web.UI.Keys.Escape&&this.get_dropDownVisible()){
if(this.get_dropDownVisible()){
this.hideDropDown();
}
return;
}
if(_67===Telerik.Web.UI.Keys.Enter){
if(this.get_dropDownVisible()){
this.hideDropDown();
}
this._performSelect(this.get_highlightedItem());
e.returnValue=false;
if(e.preventDefault){
e.preventDefault();
}
return;
}else{
if(_67===Telerik.Web.UI.Keys.Down){
e.returnValue=false;
if(e.altKey){
this.toggleDropDown();
return;
}
this.highlightNextItem();
return;
}else{
if(_67===Telerik.Web.UI.Keys.Up){
e.returnValue=false;
if(e.altKey){
this.toggleDropDown();
return;
}
this.highlightPreviousItem();
return;
}else{
if(_67===Telerik.Web.UI.Keys.Tab){
if(this.get_dropDownVisible()){
this.hideDropDown();
}
this._raiseClientBlur();
this._selectItemOnBlur();
this._focused=false;
return;
}
}
}
}
if(_67==Telerik.Web.UI.Keys.Left||_67==Telerik.Web.UI.Keys.Right){
return;
}
},_onImageClick:function(e){
if(this._enabled){
this._selectFirstMatch();
this.toggleDropDown();
}
},_onInputClick:function(e){
if(this._enabled){
this._selectFirstMatch();
this.selectText(0,this.get_text().length);
if(!this.get_dropDownVisible()&&this._showDropDownOnTextboxClick){
this.showDropDown();
}
return true;
}
},_onMoreResultsBoxClick:function(e){
this.requestItems(this.get_text(),true);
},_onMoreResultsBoxOver:function(e){
this.get_moreResultsBoxElement().style.cursor="pointer";
},_onMoreResultsBoxOut:function(e){
this.get_moreResultsBoxElement().style.cursor="default";
},_onFocus:function(e){
if(this._focused){
return;
}
var _6e=this.get_tableElement();
if(_6e!=null){
_6e.className="rcbFocused";
}
if(this.get_emptyMessage()){
this.get_inputDomElement().value=this._text;
this.get_inputDomElement().className="rcbInput";
}
if(!e){
e=event;
}
this._focused=true;
this.raise_onClientFocus();
return true;
},_raiseClientBlur:function(){
if(this._focused){
var _6f=this.get_tableElement();
if(_6f!=null){
_6f.className="";
}
if(this.get_emptyMessage()&&(this.get_text()=="")){
this.get_inputDomElement().value=this.get_emptyMessage();
this.get_inputDomElement().className+=" rcbEmptyMessage";
}
this.raise_onClientBlur();
}
},_onInputChange:function(){
this.set_value("");
var _70=this.get_text();
if(this.get_emptyMessage()!=""&&_70!=this.get_emptyMessage()){
this._text=_70;
}
this.get_element().value=this._text;
this.updateClientState();
if(this.get_enableLoadOnDemand()&&!this._suppressChange){
var me=this;
if(this._requestTimeoutID>0){
window.clearTimeout(this._requestTimeoutID);
this._requestTimeoutID=0;
}
if(!this._showDropDownOnTextboxClick){
this._skipLoadingItems=true;
}
if(!this.get_dropDownVisible()){
this.showDropDown();
}
this._requestTimeoutID=window.setTimeout(function(){
if(me._isInPostBack){
return;
}
me.requestItems(me.get_text(),false);
},me.get_itemRequestTimeout());
return;
}
if(!this._suppressChange&&this._shouldHighlight()){
this.highlightMatches();
}
},_onInputPropertyChange:function(){
if(event.propertyName=="value"){
var _72=this.get_text();
if(this._cachedText!=_72){
this._cachedText=_72;
this._onInputChange();
}
}
},_shouldHighlight:function(){
if(this._lastKeyCode<Telerik.Web.UI.Keys.Space){
return false;
}
if(this._lastKeyCode>=Telerik.Web.UI.Keys.PageUp&&this._lastKeyCode<=Telerik.Web.UI.Keys.Del){
return false;
}
if(this._lastKeyCode>=Telerik.Web.UI.Keys.F1&&this._lastKeyCode<=Telerik.Web.UI.Keys.F12){
return false;
}
return true;
},get_dropDownElement:function(){
if(!this._dropDownElement){
this._dropDownElement=this._getChildElement("DropDown");
}
return this._dropDownElement;
},get_inputDomElement:function(){
if(!this._inputDomElement){
this._inputDomElement=this._getChildElement("Input");
}
return this._inputDomElement;
},get_moreResultsBoxMessageElement:function(){
var box=this.get_moreResultsBoxElement();
var _74=$telerik.getFirstChildByTagName(box,"span",0);
return _74;
},get_moreResultsBoxElement:function(){
var box=this._getChildElement("MoreResultsBox");
return box;
},get_emptyMessage:function(){
return this._emptyMessage;
},set_emptyMessage:function(_76){
if(this._emptyMessage!==_76){
this._emptyMessage=_76;
}
},get_imageDomElement:function(){
if(!this._imageDomElement){
this._imageDomElement=this._getChildElement("Arrow");
}
return this._imageDomElement;
},get_slideDirection:function(){
return this._slideDirection;
},set_slideDirection:function(_77){
this._slideDirection=_77;
this._slide.set_direction(_77);
},hideDropDown:function(){
if(this.raise_dropDownClosing(this)==true){
return;
}
this.get_dropDownElement().style.display="none";
if(!this._getAnimationContainer()){
return;
}
this._slide.collapse();
this.set_dropDownVisible(false);
},showDropDown:function(){
if(this._isInPostBack){
return;
}
if(this.raise_dropDownOpening(this)==true){
return;
}
var _78=this._getAnimationContainer();
if(!_78){
return;
}
if(this.get_enableLoadOnDemand()&&this.get_items().get_count()==0&&!this._skipLoadingItems){
this.requestItems(this.get_text(),false);
}
_78.style.visibility="hidden";
this.get_dropDownElement().style.visibility="hidden";
this._slide.show();
this._resetAnimatedElementPosition();
this._slide.set_direction(this.get_slideDirection());
this.get_inputDomElement().focus();
this._onFocus();
this.set_dropDownVisible(true);
this._positionDropDown();
var _79=this.get_dropDownElement();
_79.style.top=-_79.offsetHeight+"px";
this._slide.updateSize();
_78.style.visibility="visible";
this._slide.expand();
},toggleDropDown:function(){
if(this.get_dropDownVisible()){
this.hideDropDown();
}else{
this.showDropDown();
if(this.get_highlightedItem()){
this.get_highlightedItem().scrollIntoView();
}
}
},_resetAnimatedElementPosition:function(){
var _7a=this._getAnimatedElement();
_7a.style.top="0px";
_7a.style.left="0px";
},_performSelect:function(_7b){
if(_7b&&_7b!=this.get_selectedItem()&&!this.get_enableLoadOnDemand()){
_7b.select();
return;
}
if(_7b&&_7b==this.get_selectedItem()&&this.get_text()!=_7b.get_text()&&this.get_allowCustomText()){
this.set_text(_7b.get_text());
return;
}
if(_7b&&_7b==this.get_selectedItem()){
return;
}
if(_7b&&this.get_originalText()!=_7b.get_text()){
_7b.select();
return;
}
if(_7b&&(!this.get_selectedItem()||this.get_selectedItem().get_value()!=_7b.get_value())){
_7b.select();
return;
}
if(this.get_originalText()!=this.get_text()){
if(this.get_highlightedItem()){
this.get_highlightedItem().unHighlight();
}
var _7c={Command:"TextChanged"};
this.postback(_7c);
}
},set_value:function(_7d){
this._value=_7d;
this.updateClientState();
},get_value:function(){
return this._value;
},set_text:function(_7e){
this.get_element().value=_7e;
this._suppressChange=true;
var _7f=this.get_inputDomElement();
_7f.value=_7e;
this.set_value("");
if(_7f.fireEvent){
var _80=document.createEventObject();
_7f.fireEvent("onchange",_80);
}else{
if(_7f.dispatchEvent){
var _81=true;
var _80=document.createEvent("HTMLEvents");
_80.initEvent("change",_81,true);
_7f.dispatchEvent(_80);
}
}
this._suppressChange=false;
this._text=_7e;
this.updateClientState();
},get_webServiceSettings:function(){
return this._webServiceSettings;
},set_webServiceSettings:function(_82){
var _83=Sys.Serialization.JavaScriptSerializer.deserialize(_82);
this._webServiceSettings=new Telerik.Web.UI.WebServiceSettings(_83);
},get_text:function(){
return this.get_inputDomElement().value;
},enable:function(){
this.get_inputDomElement().disabled=false;
var _84=this.get_tableElement();
if(_84!=null){
_84.className="";
}
this.set_enabled(true);
this.enableEvents();
var _85=this._children.get_count();
for(var i=0;i<_85;i++){
this._children.getItem(i).enable();
}
},disable:function(){
var _87=this.get_tableElement();
if(_87!=null){
_87.className="rcbDisabled";
}
this.set_enabled(false);
this.set_value(this.get_text());
this.get_inputDomElement().disabled="disabled";
this.disableEvents();
var _88=this._children.get_count();
for(var i=0;i<_88;i++){
this._children.getItem(i).disable();
}
},set_enabled:function(_8a){
this._enabled=_8a;
this.updateClientState();
},get_enabled:function(){
return this._enabled;
},disableEvents:function(){
this._fireEvents=false;
},enableEvents:function(){
this._fireEvents=true;
},findItemByText:function(_8b){
var _8c=this.get_items();
for(var i=0;i<_8c.get_count();i++){
if(_8c.getItem(i).get_text()==_8b){
return _8c.getItem(i);
}
}
return null;
},findItemByValue:function(_8e){
if(!_8e){
return null;
}
var _8f=this.get_items();
for(var i=0;i<_8f.get_count();i++){
if(_8f.getItem(i).get_value()==_8e){
return _8f.getItem(i);
}
}
return null;
},_getAnimationContainer:function(){
if(!this._animationContainer){
if(this.get_dropDownElement()){
this._animationContainer=this.get_dropDownElement().parentNode;
}
}
return this._animationContainer;
},highlightPreviousItem:function(){
var _91=this.get_items();
var _92=this.get_highlightedItem();
var _93=0;
if(_92){
_93=_92.get_index()-1;
}
_93=this._findPrevAvailableIndex(_93);
if(_93>=0){
_91.getItem(_93).highlight();
_91.getItem(_93).scrollIntoView();
var _94=this._getLastSeparatorIndex(this.get_text());
var _95=this.get_text().substring(0,_94+1)+_91.getItem(_93).get_text();
if(this.get_changeText()){
this.set_text(_95);
this.set_value(_91.getItem(_93).get_value());
}
}
},highlightNextItem:function(){
var _96=this.get_items();
var _97=this.get_highlightedItem();
var _98=0;
if(_97){
_98=_97.get_index()+1;
}
_98=this._findNextAvailableIndex(_98);
if(_98<_96.get_count()){
_96.getItem(_98).highlight();
_96.getItem(_98).scrollIntoView();
var _99=this._getLastSeparatorIndex(this.get_text());
var _9a=this.get_text().substring(0,_99+1)+_96.getItem(_98).get_text();
if(this.get_changeText()){
this.set_text(_9a);
this.set_value(_96.getItem(_98).get_value());
}
}
},findFirstMatch:function(_9b){
if(!_9b){
return null;
}
var _9c=this.get_items();
for(var i=0;i<_9c.get_count();i++){
if(_9c.getItem(i).get_text().length<_9b.length){
continue;
}
if(_9c.getItem(i).get_enabled()==false){
continue;
}
var _9e=_9c.getItem(i).get_text().substring(0,_9b.length);
if(!this.get_isCaseSensitive()){
if(_9e.toLowerCase()==_9b.toLowerCase()){
return _9c.getItem(i);
}
}else{
if(_9e==_9b){
return _9c.getItem(i);
}
}
}
return null;
},highlightMatches:function(){
if(!this.get_markFirstMatch()){
return;
}
var _9f=this.get_text();
var _a0=this.getLastWord(_9f);
if(this._getLastSeparator(_9f)==_9f.charAt(_9f.length-1)){
return;
}
var _a1=this.findFirstMatch(_a0);
if(this.get_highlightedItem()){
this.get_highlightedItem().unHighlight();
}
if(!_a1){
if(!this.get_allowCustomText()){
if(_9f){
var _a2=this._getLastSeparatorIndex(_9f);
if(_a2<_9f.length-1){
this.set_text(_9f.substring(0,_9f.length-1));
this.highlightMatches();
}
}
}
return;
}
_a1.highlight();
_a1.scrollOnTop();
var _a2=this._getLastSeparatorIndex(_9f);
var _a3=_9f.substring(0,_a2+1)+_a1.get_text();
if(_9f!=_a3){
this.set_text(_a3);
}
this.set_value(_a1.get_value());
var _a4=_a2+_a0.length+1;
var _a5=_a3.length-_a4;
this.selectText(_a4,_a5);
},postback:function(_a6){
if(!this._postBackReference){
return;
}
var _a7=this._postBackReference.replace("arguments",Sys.Serialization.JavaScriptSerializer.serialize(_a6));
eval(_a7);
},_getLastSeparator:function(_a8){
if(!this.get_autoCompleteSeparator()){
return null;
}
var _a9=this._getLastSeparatorIndex(_a8);
return _a8.charAt(_a9);
},getLastWord:function(_aa){
var _ab=-1;
if(this.get_autoCompleteSeparator()!=null){
_ab=this._getLastSeparatorIndex(_aa);
}
var _ac=_aa.substring(_ab+1,_aa.length);
return _ac;
},_getLastSeparatorIndex:function(_ad){
var _ae=-1;
if(!this.get_autoCompleteSeparator()){
return _ae;
}
for(var i=0;i<this.get_autoCompleteSeparator().length;i++){
var _b0=this.get_autoCompleteSeparator().charAt(i);
var _b1=_ad.lastIndexOf(_b0);
if(_b1>_ae){
_ae=_b1;
}
}
return _ae;
},selectText:function(_b2,_b3){
if(this.get_inputDomElement().createTextRange){
var _b4=this.get_inputDomElement().createTextRange();
if(_b2==0&&_b3==0){
_b4.collapse(true);
return;
}
_b4.moveStart("character",_b2);
_b4.moveEnd("character",_b3);
_b4.select();
}else{
this.get_inputDomElement().setSelectionRange(_b2,_b2+_b3);
}
},_childRemoved:function(_b5,_b6){
var _b7=_b5.get_element();
if(_b5==this.get_selectedItem()){
this.set_selectedItem(null);
this.set_highlightedItem(null);
this.set_text("");
}
if(_b6.get_items().get_count()==0&&!this._getHeaderElement()){
_b7=_b6._childListElement;
_b6._childListElement=null;
}
if(_b7){
_b7.innerHTML="";
if(_b7.parentNode){
_b7.parentNode.removeChild(_b7);
}
_b7=null;
}
Telerik.Web.UI.RadComboBox.callBaseMethod(this,"_childRemoved",[_b5,_b6]);
},_childrenCleared:function(_b8){
var _b9=_b8.get_childListElement();
if(_b9&&!this._getHeaderElement()){
for(var i=0;i<_b8.get_items().get_count();i++){
_b8.get_items().getItem(i)._dispose();
}
_b9.innerHTML="";
_b9=null;
}else{
if(_b9){
for(var i=0;i<_b8.get_items().get_count();i++){
this._childRemoved(_b8.get_items().getItem(i),_b8);
}
}
}
},_createChildControls:function(){
this._children=new Telerik.Web.UI.RadComboBoxItemCollection(this);
Telerik.Web.UI.RadComboBox._createChildControls(this,this._children);
},_createChildListElement:function(){
var _bb=document.createElement("ul");
_bb.className="rcbList";
this.get_childListElementWrapper().appendChild(_bb);
this._onDropDownClickDelegate=Function.createDelegate(this,this._onDropDownClick);
$addHandler(this.get_childListElement(),"click",this._onDropDownClickDelegate);
this._onDropDownHoverDelegate=Function.createDelegate(this,this._onDropDownHover);
$addHandler(this.get_childListElement(),"mouseover",this._onDropDownHoverDelegate);
$addHandler(this.get_childListElement(),"selectstart",this._cancelEvent);
$addHandler(this.get_childListElement(),"dragstart",this._cancelEvent);
this._onDropDownOutDelegate=Function.createDelegate(this,this._onDropDownOut);
$addHandler(this.get_childListElement(),"mouseout",this._onDropDownOutDelegate);
},get_childListElement:function(){
if(!this._childListElement){
var _bc=this.get_childListElementWrapper();
this._childListElement=$telerik.getFirstChildByTagName(_bc,"ul",0);
}
return this._childListElement;
},get_childListElementWrapper:function(){
if(!this._childListElementWrapper){
var _bd=this.get_dropDownElement();
if(this._getHeaderElement()){
this._childListElementWrapper=$telerik.getFirstChildByTagName(_bd,"div",1);
}else{
this._childListElementWrapper=$telerik.getFirstChildByTagName(_bd,"div",0);
}
}
return this._childListElementWrapper;
},_getHeaderElement:function(){
if(this.get_dropDownElement()){
return $telerik.getChildByClassName(this.get_dropDownElement(),"rcbHeader",0);
}
return null;
},get_tableElement:function(){
if(!this._tableElement){
this._tableElement=$telerik.getFirstChildByTagName(this.get_element(),"table",0);
}
return this._tableElement;
},get_expandAnimation:function(){
return this._expandAnimation;
},set_expandAnimation:function(_be){
var _bf=Sys.Serialization.JavaScriptSerializer.deserialize(_be);
this._expandAnimation=new Telerik.Web.UI.AnimationSettings(_bf);
},get_collapseAnimation:function(){
return this._collapseAnimation;
},set_collapseAnimation:function(_c0){
var _c1=Sys.Serialization.JavaScriptSerializer.deserialize(_c0);
this._collapseAnimation=new Telerik.Web.UI.AnimationSettings(_c1);
},_getAnimatedElement:function(){
if(!this._animatedElement){
this._animatedElement=this.get_dropDownElement();
}
return this._animatedElement;
},get_items:function(){
return this._getChildren();
},set_items:function(_c2){
this._children=_c2;
},get_itemData:function(){
return this._itemData;
},set_itemData:function(_c3){
this._itemData=_c3;
},get_itemRequestTimeout:function(){
return this._itemRequestTimeout;
},set_itemRequestTimeout:function(_c4){
this._itemRequestTimeout=_c4;
},get_appendItems:function(){
return this._appendItems;
},set_appendItems:function(_c5){
this._appendItems=_c5;
},get_selectedItem:function(){
return this._selectedItem;
},set_selectedItem:function(_c6){
this._selectedItem=_c6;
},get_selectedIndex:function(){
var _c7=this.get_selectedItem();
if(_c7){
return _c7.get_index();
}
return this._selectedIndex;
},set_selectedIndex:function(_c8){
this._selectedIndex=_c8;
},get_causesValidation:function(){
return this._causesValidation;
},set_causesValidation:function(_c9){
this._causesValidation=_c9;
},get_closeDropDownOnBlur:function(){
return this._closeDropDownOnBlur;
},set_closeDropDownOnBlur:function(_ca){
this._closeDropDownOnBlur=_ca;
},get_isTemplated:function(){
return this._isTemplated;
},set_isTemplated:function(_cb){
this._isTemplated=_cb;
},get_highlightTemplatedItems:function(){
return this._highlightTemplatedItems;
},set_highlightTemplatedItems:function(_cc){
this._highlightTemplatedItems=_cc;
},get_enableLoadOnDemand:function(){
return this._enableLoadOnDemand;
},set_enableLoadOnDemand:function(_cd){
this._enableLoadOnDemand=_cd;
},get_allowCustomText:function(){
return this._allowCustomText;
},set_allowCustomText:function(_ce){
this._allowCustomText=_ce;
},get_changeText:function(){
return this._changeText;
},set_changeText:function(_cf){
this._changeText=_cf;
},get_markFirstMatch:function(){
return this._markFirstMatch;
},set_markFirstMatch:function(_d0){
this._markFirstMatch=_d0;
},get_originalText:function(){
return this._originalText;
},set_originalText:function(_d1){
this._originalText=_d1;
},get_highlightedItem:function(){
return this._highlightedItem;
},set_highlightedItem:function(_d2){
this._highlightedItem=_d2;
},get_isCaseSensitive:function(){
return this._isCaseSensitive;
},set_isCaseSensitive:function(_d3){
this._isCaseSensitive=_d3;
},get_dropDownVisible:function(){
return this._dropDownVisible;
},set_dropDownVisible:function(_d4){
this._dropDownVisible=_d4;
},get_autoCompleteSeparator:function(){
return this._autoCompleteSeparator;
},set_autoCompleteSeparator:function(_d5){
this._autoCompleteSeparator=_d5;
},get_showMoreMessage:function(){
return this._showMoreMessage;
},set_showMoreMessage:function(_d6){
this._showMoreMessage=_d6;
},get_loadingMessage:function(){
return this._loadingMessage;
},set_loadingMessage:function(_d7){
this._loadingMessage=_d7;
},get_errorMessage:function(){
return this._errorMessage;
},set_errorMessage:function(_d8){
this._errorMessage=_d8;
},set_endOfItems:function(_d9){
this._endOfItems=_d9;
},get_endOfItems:function(){
return this._endOfItems;
},get_clientDataString:function(){
return this._clientDataString;
},set_clientDataString:function(_da){
this._clientDataString=_da;
},get_offsetX:function(){
return this._offsetX;
},set_offsetX:function(_db){
this._offsetX=_db;
},get_offsetY:function(){
return this._offsetY;
},set_offsetY:function(_dc){
this._offsetY=_dc;
},add_keyPressing:function(_dd){
this.get_events().addHandler("keyPressing",_dd);
},remove_keyPressing:function(_de){
this.get_events().removeHandler("keyPressing",_de);
},raise_keyPressing:function(_df){
this.raiseEvent("keyPressing",_df);
},add_selectedIndexChanging:function(_e0){
this.get_events().addHandler("selectedIndexChanging",_e0);
},remove_selectedIndexChanging:function(_e1){
this.get_events().removeHandler("selectedIndexChanging",_e1);
},raise_selectedIndexChanging:function(_e2){
var _e3=new Telerik.Web.UI.RadComboBoxItemCancelEventArgs(_e2);
this.raiseEvent("selectedIndexChanging",_e3);
return _e3.get_cancel();
},add_selectedIndexChanged:function(_e4){
this.get_events().addHandler("selectedIndexChanged",_e4);
},remove_selectedIndexChanged:function(_e5){
this.get_events().removeHandler("selectedIndexChanged",_e5);
},raise_selectedIndexChanged:function(_e6){
var _e7=new Telerik.Web.UI.RadComboBoxItemEventArgs(_e6);
this.raiseEvent("selectedIndexChanged",_e7);
},add_itemsRequesting:function(_e8){
this.get_events().addHandler("itemsRequesting",_e8);
},remove_itemsRequesting:function(_e9){
this.get_events().removeHandler("itemsRequesting",_e9);
},add_itemsRequested:function(_ea){
this.get_events().addHandler("itemsRequested",_ea);
},remove_itemsRequested:function(_eb){
this.get_events().removeHandler("itemsRequested",_eb);
},raise_itemsRequested:function(_ec){
var _ed=new Telerik.Web.UI.RadComboBoxRequestEventArgs(_ec);
this.raiseEvent("itemsRequested",_ed);
},add_dropDownOpening:function(_ee){
this.get_events().addHandler("dropDownOpening",_ee);
},remove_dropDownOpening:function(_ef){
this.get_events().removeHandler("dropDownOpening",_ef);
},raise_dropDownOpening:function(){
var _f0=new Telerik.Web.UI.RadComboBoxCancelEventArgs();
this.raiseEvent("dropDownOpening",_f0);
return _f0.get_cancel();
},add_dropDownClosing:function(_f1){
this.get_events().addHandler("dropDownClosing",_f1);
},remove_dropDownClosing:function(_f2){
this.get_events().removeHandler("dropDownClosing",_f2);
},add_itemsRequestFailed:function(_f3){
this.get_events().addHandler("itemsRequestFailed",_f3);
},remove_itemsRequestFailed:function(_f4){
this.get_events().removeHandler("itemsRequestFailed",_f4);
},raise_itemsRequestFailed:function(_f5,_f6){
var _f7=new Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs(_f5,_f6);
this.raiseEvent("itemsRequestFailed",_f7);
return _f7.get_cancel();
},raise_dropDownClosing:function(){
var _f8=new Telerik.Web.UI.RadComboBoxCancelEventArgs();
this.raiseEvent("dropDownClosing",_f8);
return _f8.get_cancel();
},add_onClientFocus:function(_f9){
this.get_events().addHandler("onClientFocus",_f9);
},remove_onClientFocus:function(_fa){
this.get_events().removeHandler("onClientFocus",_fa);
},raise_onClientFocus:function(){
var _fb=new Telerik.Web.UI.RadComboBoxEventArgs();
this.raiseEvent("onClientFocus",_fb);
},add_onClientBlur:function(_fc){
this.get_events().addHandler("onClientBlur",_fc);
},remove_onClientBlur:function(_fd){
this.get_events().removeHandler("onClientBlur",_fd);
},raise_onClientBlur:function(){
var _fe=new Telerik.Web.UI.RadComboBoxEventArgs();
this.raiseEvent("onClientBlur",_fe);
},add_onClientKeyPressing:function(_ff){
this.get_events().addHandler("keyPressing",_ff);
},remove_onClientKeyPressing:function(_100){
this.get_events().removeHandler("keyPressing",_100);
},raise_onClientKeyPressing:function(e){
this.raiseEvent("keyPressing",e);
},add_load:function(_102){
this.get_events().addHandler("load",_102);
},remove_load:function(_103){
this.get_events().removeHandler("load",_103);
},_logInserted:function(item){
if(!item.get_parent()._childControlsCreated||!this._enableClientStatePersistence){
return;
}
this._log.logInsert(item);
},saveClientState:function(){
var _105=this._log._logEntries;
var _106={logEntries:_105,value:this._value,text:this._text,enabled:this._enabled};
return Sys.Serialization.JavaScriptSerializer.serialize(_106);
},requestItems:function(text,_108){
if(this._isInPostBack){
return;
}
text=text.replace(/'/g,"&squote");
text=encodeURIComponent(text);
this._ajaxRequest=true;
var _109={};
this.set_appendItems(_108);
var _10a=new Telerik.Web.UI.RadComboBoxRequestCancelEventArgs(text,_109);
this.raiseEvent("itemsRequesting",_10a);
if(_10a.get_cancel()){
return;
}
if(this.get_highlightedItem()){
this.get_highlightedItem().unHighlight();
}
if(!this._loadingDiv){
this._loadingDiv=document.createElement("li");
this._loadingDiv.className="rcbLoading";
this._loadingDiv.id=this.get_id()+"_LoadingDiv";
this._loadingDiv.innerHTML=this.get_loadingMessage();
if(!this.get_childListElement()){
this._createChildListElement();
}
this.get_childListElement().insertBefore(this._loadingDiv,this.get_childListElement().firstChild);
}
_109.NumberOfItems=0;
if(this.get_appendItems()){
_109.NumberOfItems=this.get_items().get_count();
}
_109.Text=text;
if(this.get_webServiceSettings().get_method()){
this._doLoadOnDemandFromWebService(text,_109);
}else{
this._doLoadOnDemand(text,_109);
}
},_doLoadOnDemand:function(text,_10c){
var _10d=0;
if(this.get_appendItems()){
_10d=this.get_items().get_count();
}
var _10e={Command:"LOD",Text:text,ClientState:this._clientState,Context:_10c,NumberOfItems:_10d};
var _10f=Function.createDelegate(this,this._onCallbackResponse);
var _110=Function.createDelegate(this,this._onErrorReceived);
WebForm_DoCallback(this._uniqueId,Sys.Serialization.JavaScriptSerializer.serialize(_10e),_10f,text,_110,true);
},_onCallbackResponse:function(_111){
this.set_selectedItem(null);
this.set_highlightedItem(null);
var _112=this._children.get_count();
var _113=_111.split("_$$_");
var _114;
if(_113[0]=="[]"){
_114=null;
}else{
_114=eval(_113[0]);
}
if(_113[3]=="True"){
this._endOfItems=true;
}else{
this._endOfItems=false;
}
if(this.get_appendItems()&&this._itemData&&_114){
Array.addRange(this._itemData,_114);
}else{
this._itemData=_114;
}
if(this._loadingDiv){
if(this._loadingDiv.parentNode){
this._loadingDiv.parentNode.removeChild(this._loadingDiv);
}
this._loadingDiv=null;
}
var _115=this.get_childListElement();
if(!_115){
_115=this._createChildListElement();
}
var _116=_115.innerHTML;
var _117=this._getHeaderElement();
this._childControlsCreated=true;
var _118=$telerik.getFirstChildByTagName(_115,"div",0);
if(_118){
_118.parentNode.removeChild(_118);
}
if(this.get_appendItems()){
var _119=document.createElement("ul");
_119.innerHTML=_113[1];
var _11a=$telerik.getChildrenByTagName(_119,"li");
var _11b=_11a.length;
for(var i=0;i<_11a.length;i++){
_115.appendChild(_11a[i]);
this._childControlsCreated=false;
var item=new Telerik.Web.UI.RadComboBoxItem();
this._children.add(item);
item._initialize(_114[i],_11a[i]);
}
if(this._virtualScroll){
this._setUpScroll(this._endOfItems,_115);
}
if(this._children.getItem(_112+1)!=null){
if(this._virtualScroll){
this._virtualScroll=false;
this._children.getItem(_112+1).scrollIntoView();
this._virtualScroll=true;
}
}
}else{
this._children.clear();
if(_117){
_115.innerHTML=_115.innerHTML+_113[1];
}else{
_115.innerHTML=_113[1];
}
this._childControlsCreated=false;
this._createChildControls();
if(this._virtualScroll){
this._setUpScroll(this._endOfItems,_115);
}
}
if(this._showMoreResultsBox&&this.get_moreResultsBoxMessageElement()){
this.get_moreResultsBoxMessageElement().innerHTML=_113[2];
}
this.highlightMatches();
this.raise_itemsRequested(this.get_text());
if(this.get_dropDownVisible()){
if(this._slide){
this._slide.updateSize();
}
this._positionDropDown();
}
this._ajaxRequest=false;
},_setUpScroll:function(_11e,_11f){
var _120=22;
var _121=this.get_items().get_count();
if(_121>0){
_120=this.get_items().getItem(0).get_element().offsetHeight;
}
if(_11e){
var _122=$telerik.getFirstChildByTagName(_11f,"div",0);
if(_122){
_122.parentNode.removeChild(_122);
}
}else{
var _122=document.createElement("div");
_122.style.height=this.get_childListElementWrapper().offsetHeight+"px";
_11f.appendChild(_122);
}
},_onErrorReceived:function(_123,text){
if(this._requestTimeoutID>0){
window.clearTimeout(this._requestTimeoutID);
this._requestTimeoutID=0;
}
var _125=this._extractErrorMessage(_123);
if(this.raise_itemsRequestFailed(text,_125)==true){
return;
}
alert(_125);
},_initializeWebServiceLoader:function(){
this._webServiceLoader=new Telerik.Web.UI.WebServiceLoader(this.get_webServiceSettings());
this._webServiceLoader.add_loadingSuccess(Function.createDelegate(this,this._onWebServiceResponse));
this._webServiceLoader.add_loadingError(Function.createDelegate(this,this._onWebServiceError));
},_doLoadOnDemandFromWebService:function(text,_127){
if(!this._webServiceLoader){
this._initializeWebServiceLoader();
}
var _128={context:_127};
this._webServiceLoader.loadData(_128,text);
},_onWebServiceResponse:function(_129,_12a){
var _12b=_12a.get_data();
var text=_12a.get_context();
this.set_selectedItem(null);
this.set_highlightedItem(null);
var _12d=this.get_items().get_count();
this._childControlsCreated=true;
if(this._loadingDiv){
if(this._loadingDiv.parentNode){
this._loadingDiv.parentNode.removeChild(this._loadingDiv);
}
this._loadingDiv=null;
}
var _12e=this.get_childListElement();
if(!_12e){
_12e=this._createChildListElement();
}
if(!this.get_appendItems()){
this.clearItems();
}
if(this._virtualScroll){
this._setUpScroll(true,_12e);
}
var _12f=null;
if(Array.prototype.isPrototypeOf(_12b)){
_12f=_12b;
}else{
_12f=_12b.Items;
this._endOfItems=_12b.EndOfItems;
this._showMoreMessage=_12b.Message;
}
for(var i=0;i<_12f.length;i++){
var item=new Telerik.Web.UI.RadComboBoxItem();
var data=_12f[i];
item._loadFromDictionary(data);
this._children.add(item);
}
if(this._virtualScroll){
this._setUpScroll(this._endOfItems,_12e);
}
if(this.get_appendItems()){
if(this.get_items().getItem(_12d+1)!=null){
this.get_items().getItem(_12d+1).scrollIntoView();
}
}
if(this._showMoreResultsBox&&this.get_moreResultsBoxMessageElement()){
this.get_moreResultsBoxMessageElement().innerHTML=this.get_showMoreMessage();
}
this.raise_itemsRequested(text);
if(this._shouldHighlight()){
this.highlightMatches();
}
if(this.get_dropDownVisible()){
if(this._slide){
this._slide.updateSize();
}
this._positionDropDown();
}
this._ajaxRequest=false;
},_onWebServiceError:function(_133,_134){
var _135=_134.get_message();
var text=_134.get_context();
this._onErrorReceived(_135,text);
}};
Telerik.Web.UI.RadComboBox.registerClass("Telerik.Web.UI.RadComboBox",Telerik.Web.UI.ControlItemContainer);;Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadComboBoxItem=function(){
Telerik.Web.UI.RadComboBoxItem.initializeBase(this);
this._highlighted=false;
};
Telerik.Web.UI.RadComboBoxItem.prototype={_shouldInitializeChild:function(_1){
return false;
},_render:function(_2){
_2[_2.length]="<li class='";
if(this.get_enabled()){
_2[_2.length]="rcbItem'>";
}else{
_2[_2.length]="rcbDisabled'>";
}
_2[_2.length]=this.get_text();
_2[_2.length]="</li>";
},get_value:function(){
return this._properties.getValue("value","");
},select:function(){
if(!this.get_isEnabled()){
return;
}
var _3=this.get_comboBox();
if(_3.raise_selectedIndexChanging(this)==true){
return;
}
var _4=_3.get_text();
var _5=_3._getLastSeparatorIndex(_4);
var _6=_4.substring(0,_5+1)+this.get_text();
_3.set_text(_6);
_3.set_originalText(_6);
_3.set_value(this.get_value());
_3.set_selectedItem(this);
_3.set_selectedIndex(this.get_index());
this.highlight();
_3.raise_selectedIndexChanged(this);
var _7={Command:"Select",Index:this.get_index()};
_3.postback(_7);
},_createChildControls:function(){
},unHighlight:function(){
var _8=this.get_comboBox();
if(!_8.get_isTemplated()||_8.get_highlightTemplatedItems()){
this._replaceCssClass(this.get_element(),"rcbHovered","rcbItem");
}
_8.set_highlightedItem(null);
this.set_highlighted(false);
},highlight:function(){
if(!this.get_isEnabled()){
return;
}
var _9=this.get_comboBox();
if(!_9.get_isTemplated()||_9.get_highlightTemplatedItems()){
var _a=_9.get_highlightedItem();
if(_a){
_a.unHighlight();
}
var _b=this.get_element();
if(_b){
this._replaceCssClass(_b,"rcbItem","rcbHovered");
}
}
_9.set_highlightedItem(this);
this.set_highlighted(true);
},scrollOnTop:function(){
var _c=this.get_element().offsetTop;
var _d=this.get_comboBox();
var _e=_d._getHeaderElement();
if(_e){
_c=_c-_e.offsetHeight;
}
_d.get_childListElementWrapper().scrollTop=_c;
},scrollIntoView:function(){
var _f=this.get_element().offsetTop;
var _10=this.get_element().offsetHeight;
var _11=this.get_comboBox().get_childListElementWrapper();
var _12=_11.scrollTop;
var _13=_11.offsetHeight;
if(_f+_10>_12+_13){
_11.scrollTop=_f+_10-_13;
}else{
if(_f+_10<=_12){
_11.scrollTop=_f;
}
}
},nextItem:function(){
return this.get_comboBox().get_items().getItem(this.get_index()+1);
},_replaceCssClass:function(_14,_15,_16){
_14.className=_14.className.replace(_15,_16);
},_createChildListElement:function(){
var _17=document.createElement("ul");
this.get_combobox().get_dropDownElement().appendChild(_17);
},set_selected:function(_18){
this._properties.setValue("selected",_18);
},get_selected:function(){
return this._properties.getValue("selected",false);
},set_highlighted:function(_19){
this._highlighted=_19;
},get_highlighted:function(){
return this._highlighted;
},disable:function(){
this.set_enabled(false);
this.get_element().className="rcbDisabled";
},enable:function(){
this.set_enabled(true);
this.get_element().className="rcbItem";
},get_textElement:function(){
return this.get_element();
},get_comboBox:function(){
return this._parent;
},_getHierarchicalIndex:function(){
return this.get_index();
}};
Telerik.Web.UI.RadComboBoxItem.registerClass("Telerik.Web.UI.RadComboBoxItem",Telerik.Web.UI.ControlItem);;Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadComboBoxItemCollection=function(_1){
Telerik.Web.UI.RadComboBoxItemCollection.initializeBase(this,[_1]);
};
Telerik.Web.UI.RadComboBoxItemCollection.prototype={};
Telerik.Web.UI.RadComboBoxItemCollection.registerClass("Telerik.Web.UI.RadComboBoxItemCollection",Telerik.Web.UI.ControlItemCollection);;